// This file modelise a great wor memory. A work is a job of slave.

#include <stdio.h>
#include "work_catch.h"


#define SIZE_ARRAY_WORK 65000

Work *work_array[SIZE_ARRAY_WORK];

int nbr_works;

int init_work_catch() {
  int index = 0;
  nbr_works = 0;
  while(index < SIZE_ARRAY_WORK) {
    work_array[index++] = NULL;
  }
}

int add_work(char *control, int nbr_control) {
  // Add a work. If succeed then 1 else 0.
  Work *a_work;
  a_work = (Work *)(malloc(sizeof(Work)));
  if (!a_work) {
    fprintf(stderr, "Not enough memory to a_work of work_catch.\n");
    exit(0);
  }
  a_work -> control = control;
  a_work -> nbr_control = nbr_control;
  return(set_work(a_work));
}

int set_work(Work *a_work) {
  // Memory a work. If succeed return 1 else 0.
  int result = 0;
  int index = 0;
  if (nbr_works < SIZE_ARRAY_WORK) {
    while (work_array[index++] != NULL);
    work_array[index-1] = a_work;
    nbr_works++;
    result = 1;
  }
  return(result);
}

int delete_work(int number_control) {
  // Delete a work. If succeed then 1 else 0.
  int index = 0, result = 0;
  while (index < SIZE_ARRAY_WORK && result == 0) {
    if (work_array[index] != NULL) 
      if (number_control == work_array[index] -> nbr_control) {
	result = 1;
	free(work_array[index]);
	work_array[index] = NULL;
	nbr_works--;
      }
    index++;
  }
  return(result);
}

Work *give_work(int *index_work) {
  // Give a work.
  int index = 0;
  Work *result;
  result = NULL;
  while (*index_work < SIZE_ARRAY_WORK && result == 0) {
    if (work_array[*index_work] != NULL) 
      result = work_array[*index_work];
    *index_work = *index_work + 1;
  }
  return(result);
}

int number_works() {
  // Return the number of works in work catch.
  return(nbr_works);
}

/* int main() {
  char *string, *string_bis;
  int index = 0, nbr_works;
  Work *a_work;
  string = (char *)(malloc(100*sizeof(char)));
  string_bis = (char *)(malloc(100*sizeof(char)));
  init_work_catch();
  strcpy(string, "youpi");
  add_work(string, 1);
  strcpy(string_bis, "seb");
  add_work(string_bis, 2);
  nbr_works = number_works();
  printf("nbr_works = %d.\n", nbr_works);
  while (nbr_works > 0) {
    a_work = give_work(&index);
    printf("la chaine %s avec le numero de job %d.\n", a_work -> control, a_work -> nbr_control);
    nbr_works--;
  }
  delete_work(1);
  index = 0;
  nbr_works = number_works();
  while (nbr_works > 0) {
    a_work = give_work(&index);
    printf("la chaine %s avec le numero de job %d.\n", a_work -> control, a_work -> nbr_control);
    nbr_works--;
  }
  if (delete_work(4)) 
    printf("Problme.\n");

  else {
    printf("normal.\n");
    } 
  return(1);
  } */

